<script>
  import { fly } from "svelte/transition";
  import { quintOut } from "svelte/easing";

  export let menu;

  let open = false;
  const toggleMobile = () => {
    open = !open;
    toggleMobileButton(!open ? window.scrollY : 0);
  };

  let timeout;
  function scroll() {
    clearTimeout(timeout);

    if (!timeout) toggleMobileButton(0);

    timeout = setTimeout(() => {
      timeout = false;
      toggleMobileButton(window.scrollY);
    }, 200);
  }

  let openFixed = false;
  function toggleMobileButton(y) {
    if (y < 130 && openFixed) {
      openFixed = false;
      return;
    }

    if (y > 130 && !open) {
      openFixed = true;
    }
  }

  function hrefTarget(link) {
    if (link.slice(0, 2) == "//") {
      return "_blank";
    }
  }
  function hrefRel(link) {
    if (link.slice(0, 2) == "//") {
      return "noopener noreferrer";
    }
  }

  $: {
    document.documentElement.style.overflow = open ? "hidden" : "visible";
  }
</script>

<header>
  <div id="logo">
    <a href="//wildwoodhealth.org">
      <img src="img/logo.svg" alt="Wildwood Health Institute" />
    </a>
  </div>

  <nav class:show={open}>
    <div class="overlay" on:click={toggleMobile} />
    <ul id="menu">
      <button class="close_menu" on:click={toggleMobile}>✖ Close</button>
      {#each menu as item}
        <li class="menu_item {item.class || ''}" class:mega={item.sub}>
          <a href={item.link} title="Click to visit {item.label}">
            {item.label}
          </a>
          {#if item.sub}
            <ul>
              {#each item.sub as sub}
                <li class="menu_item">
                  <a
                    href={sub.link}
                    title="Click to visit {sub.label}"
                    target={hrefTarget(sub.link)}
                    rel={hrefRel(sub.link)}
                  >
                    {sub.label}
                  </a>
                </li>
              {/each}
            </ul>
          {/if}
        </li>
      {/each}
    </ul>
  </nav>

  <button class="open-mobile" on:click={toggleMobile}>
    <div class="hamburger" />
  </button>
</header>

<svelte:window on:scroll={scroll} />
{#if openFixed}
  <button
    transition:fly={{ x: 65, easing: quintOut }}
    class="open-mobile fixed"
    on:click={toggleMobile}
  >
    <div class="hamburger" />
  </button>
{/if}

<style>
  header {
    max-width: 1440px;
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: center;
    padding: 20px 40px;
    margin: 0 auto;
    z-index: 1;
  }

  #logo img {
    height: 86px;
  }

  #menu {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-around;
    align-items: center;
    font-size: 16px;
    font-weight: 700;
    font-family: "Lato", sans-serif;
    color: #146647;
    padding-left: 0;
  }

  #menu,
  #menu ul {
    list-style: none;
    margin: 20px 0 0;
  }

  .menu_item {
    cursor: pointer;
    margin: 0 2px;
    position: relative;
    transition: background 200ms;
    border-radius: 3px;
  }

  .menu_item:hover {
    background: #eee;
  }

  .menu_item a {
    display: block;
    padding: 10px 15px;
    text-decoration: none;
    color: inherit;
  }
  .menu_item.mega {
    padding-right: 1ch;
  }
  .menu_item.mega::after {
    position: absolute;
    content: "▼";
    font-size: 0.6em;
    top: 50%;
    right: 2ch;
    transform: translateY(-50%);
  }

  .menu_item ul {
    position: absolute;
    width: max-content;
    left: 4px;
    bottom: 0;
    background: #fff;
    font-size: 0.9em;
    padding: 5px 10px 10px;
    transform: translateY(100%);
    visibility: hidden;
    border-radius: 3px;
    border-top: 3px solid;
    z-index: 1;
  }

  .menu_item:hover ul {
    visibility: visible;
    animation: fade-in 200ms forwards;
  }

  .menu_item:last-child {
    margin: 0;
  }

  .donate {
    background: #146647;
    color: #fff;
  }

  .donate:hover {
    background: #0f4a34;
  }

  .close_menu {
    display: none;
    width: 100%;
    border: 0;
    border-bottom: 1px solid #ccc;
    background: transparent;
    cursor: pointer;
    text-align: left;
  }

  .open-mobile {
    height: 50px;
    padding: 10px;
    border-radius: 3px;
    border: 0;
    box-shadow: inset 0 0 2px #0004;
    background: #fff;
    cursor: pointer;
    z-index: 1;
    display: none;
  }

  .open-mobile.fixed {
    position: fixed;
    top: 15px;
    right: 15px;
  }

  .hamburger,
  .hamburger::before,
  .hamburger::after {
    --width: 30px;
    --gap: 2px;
    position: relative;
    content: "";
    display: block;
    width: var(--width);
    height: calc(var(--width) / 5);
    border-radius: var(--width);
    background: #2b6e46;
  }

  .hamburger::before {
    transform: translateY(calc(-100% - var(--gap)));
  }
  .hamburger::after {
    transform: translateY(var(--gap));
  }

  @keyframes fade-in {
    0% {
      visibility: hidden;
      opacity: 0;
    }

    1% {
      visibility: visible;
      opacity: 0;
    }

    100% {
      visibility: visible;
      opacity: 1;
    }
  }

  @media (max-width: 1000px) {
    .close_menu,
    .open-mobile {
      display: block;
    }

    nav {
      position: fixed;
      width: 100vw;
      height: 100vh;
      top: 0;
      left: 0;
      z-index: 1;

      display: flex;
      flex-flow: row nowrap;
      justify-content: flex-start;
      align-items: stretch;

      transform: translateX(-100%);
      transition: transform 400ms;
    }

    nav.show {
      transform: translateX(0);
    }

    .overlay {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
    }

    #menu {
      display: flex;
      flex-flow: column nowrap;
      justify-content: flex-start;
      align-items: flex-start;

      padding: 20px;
      border-right: 1px solid #ccc;
      margin-top: 0;

      background: #fff;
      box-shadow: 0 0 4px #0004;
      z-index: 1;
    }

    .menu_item {
      margin-bottom: 10px;
    }

    .menu_item.mega::after {
      content: "";
    }

    .menu_item:hover {
      background: inherit;
    }

    .menu_item:hover ul {
      animation: 0;
    }

    .menu_item ul {
      position: initial;
      visibility: visible;
      transform: none;
      padding: 0;
      border: 0;
      margin: 0;
      font-size: 0.9em;
      animation: none;
    }

    .donate:hover {
      background: #146647;
    }
  }
  @media (max-width: 400px) {
    header {
      padding: 20px;
    }
    .open-mobile {
      right: 20px;
    }
  }
</style>
